from optparse import OptionParser
import glob
import datetime
import os


# Main function implements prasing input and calling
# appropriet functions.
def Main():
    parser = OptionParser()
    parser.add_option("-g", "--glob", dest="Glob" )
    parser.add_option("-i", "--input", dest="Input" )
    parser.add_option("-o", "--output", dest="Output")
    parser.add_option("-l", "--log", action="store_true",  dest="Log_True" )
    parser.add_option("-p", "--parameter", dest="Param" )
    
    (options, args) = parser.parse_args()

    LogFile = "Log_jp22tiff.txt"
    if (options.Log_True):
        String = "Info: Script start"
        Log(LogFile,String)

    if (options.Param):
        Parameter = options.Param
    else:
        Parameter = ""

    if (options.Log_True):
        String = 'Info: Using param "' + Parameter + '"'
        Log(LogFile,String)

    if (options.Glob):
        if (options.Log_True):
            String = 'Info: Running Glob with "' + options.Glob + '"'
            Log(LogFile,String)
        List = glob.glob(options.Glob)
        for InnFilename in List:
            if (options.Output):
                OutFilename = options.Output + RemovePath(RemoveExtension(InnFilename)) + ".tif"
            else:
                OutFilename = RemoveExtension(InnFilename) + ".tif"
            if os.path.exists(OutFilename):
                continue
            
            ExecString  = "kdu_expand"
            ExecString += " -i " + InnFilename
            ExecString += " -o "+ OutFilename
            ExecString += " " + Parameter
            os.system(ExecString)


            if (options.Log_True):
                String = "Info: Compleated file " + OutFilename
                Log(LogFile,String)

    else:
        if(options.Input):
            InnFilename = options.Input
        else:
            return
        
        if (options.Output):
            OutFilename = options.Output
        else:
            OutFilename = RemoveExtension(InnFilename) + ".jp2"

        ExecString  = "kdu_expand"
        ExecString += " -i " + InnFilename
        ExecString += " -o "+ OutFilename
        ExecString += " " + Parameter
        String = "Debug: ExecString = " + ExecString
        Log(LogFile,String)
        os.system(ExecString)

        if (options.Log_True):
            String = "Info: Compleated file " + InnFilename
            Log(LogFile,String)
    
def RemoveExtension(string):
    i = string.rfind('.')
    return string[:i]
def RemovePath(string):
    i = string.rfind('\\')
    j = string.rfind('/')
    if j < i:
        return string[(i+1):]
    else:
        return string[(j+1):]
        
def Log(filename,string):
    try:
        fp1 = file(filename,'a')
        fp1.write(str(datetime.datetime.utcnow()) +"  "+ string + "\n")
        fp1.close()
    except:
       print "Error: writing to log"

Main()
