from time import clock

def LogMXFExtrackt(filename,tofolder):
    FrameNumber = 0
    fp1 = file(filename,'rb')

    Log( "Prosessing file:" + filename )

    while (True):
        SMPTE_UL = fp1.read(4)
        if (len(SMPTE_UL) == 0):
            Log( "EOF reached" )
            break
        if ( SMPTE_UL != '\x06\x0E\x2B\x34'):
            Log( "Error: Not a SMPTE Universal Lable" )
            return -1
        SMPTE_UL += fp1.read(12)
        if (len(SMPTE_UL) < 16):
            Log( "Error: EOF inside Universal Lable" )
            return -2
        Log( "SMPTE Universal Lable: " + StringToHexString(SMPTE_UL) )

        Length = fp1.read(1)
        if (Length > 127):  # > 0x7F
            #Coded in ASN.1 BER notation
            Length = ord(Length) - 128   # 0x80
            Length = fp1.read(Length)
        Length = StringToNumber(Length)
        Log( "SMPTE KLV package length: " + str(Length) )

        ReadPointer = fp1.tell() + Length

        if ( StringCompN( SMPTE_UL, '\x01\x02\x01\x01\x0D\x01\x03\x01\x15', 4) ):
            Log( "SMPTE KLV package is: GC picture item")
            EssenceElementCount = ord(SMPTE_UL[13])
            EssenceElementNumber = ord(SMPTE_UL[15])
            if ( SMPTE_UL[14] == '\x08'):
                Log( "SMPTE KLV package is: Frame-wrapped JPEG2000 picture element")
                Log( "Essence properties: EssenceElementCount=" + str(EssenceElementCount) + " EssenceElementNumber=" + str(EssenceElementNumber))
                FrameName = "%08d.j2k" % FrameNumber
                fp2 = file(tofolder + FrameName,'wb')
                fp2.write(fp1.read(Length))
                fp2.close()
                FrameNumber += 1
                
            elif ( SMPTE_UL[14] == '\x09'):
                Log( "SMPTE KLV package is: Clip-wrapped JPEG2000 picture element")
                Log( "Essence properties: EssenceElementCount=" + str(EssenceElementCount) + " EssenceElementNumber=" + str(EssenceElementNumber))
          
        fp1.seek( ReadPointer,0 )
        if ( ReadPointer != fp1.tell()):
            Log( "Error: EOF inside Value Element" )
            return -3
        
        Log( "Next KLV starts at: " + str(ReadPointer) )
    
    
    fp1.close()
    

def AddKeyToDict(dictionery, key, length):
    if (dictionery.has_key(key)):
        CumulativeLength = dictionery[key]
        dictionery[key] = CumulativeLength + length
    else:
        dictionery[key] = length
    return dictionery

def StringToNumber(string):
    OutNumber = 0
    for x in string:
        OutNumber = OutNumber * 256
        OutNumber = OutNumber + ord(x)
    return OutNumber
    

def StringToHexString(string):
    NumDiff = ord('0')
    ChrDiff = ord('A')
    OutString = ""
    for x in string:
        val = ord(x)
        Hval = ((val >> 4) & 15)
        Lval = ( val       & 15)
        if (Hval > 9):
            Hval -= 10
            OutString += chr(Hval + ChrDiff)
        else:
            OutString += chr(Hval + NumDiff)
        if (Lval > 9):
            Lval -= 10
            OutString += chr(Lval + ChrDiff)
        else:
            OutString += chr(Lval + NumDiff)
    return OutString

def Log_Reset():
    fp1 = file("dump.txt",'w')
    string = "MXF Info script v1.0.0"
    fp1.write(string + "\n")
    #print string
    fp1.close()

def Log(string):
    fp1 = file("dump.txt",'a')
    fp1.write(string + "\n")
    #print string
    fp1.close()

def StringCompN(string, sub, start):
    i = start
    j = 0
    while(i < len(string)):
        if (string[i] != sub[j]):
            return False
        i += 1
        j += 1
        if (j == len(sub)):
            return True
          

#Main seqence
StartTime = clock()
Log_Reset()
#LogMXFInfo("wav_8ae69748-3855-0140-9da1-775eac282bf5_audio.mxf")
#LogMXFInfo("jp2k_8a0b3e7e-15e0-394c-bcd1-c0417c0f3a37_video.mxf")
#LogMXFExtrackt("E:\\dk1\\DCP'er\\prad_dom_dci_arev_scop_05052006\\jp2k_1f145061-7132-d742-a9e0-59e43a342b46_video.mxf","E:\\dk1\\DCP Extraction\\jp2\\prad_dom_dci_arev_scop_05052006\\")
#LogMXFExtrackt("E:\\dk1\\DCP'er\\JohnTucker\\jp2k_ec0325f1-4d8a-b340-a3c7-a0de5685fc9b_video.mxf","E:\\dk1\\DCP Extraction\\jp2\\JohnTucker\\")
#LogMXFExtrackt("E:\\dk1\\DCP'er\\Slither\\jp2k_99821312-d944-6c4b-96fc-9d0f5358318b_video.mxf","E:\\dk1\\DCP Extraction\\jp2\\Slither\\")
LogMXFExtrackt("E:\\dk1\\DCP'er\\Breakup_wrapped\\jp2k_8a0b3e7e-15e0-394c-bcd1-c0417c0f3a37_video.mxf","E:\\dk1\\DCP Extraction\\jp2\\Breakup\\")

Log( "The time it tok to compleat was: " + str( clock() - StartTime ) )
