from time import clock

def LogMXFInfo(filename):
    CumLengthDict = {}
    fp1 = file(filename,'rb')

    Log( "Prosessing file:" + filename )

    while (True):
        SMPTE_UL = fp1.read(4)
        if (len(SMPTE_UL) == 0):
            Log( "EOF reached" )
            break
        if ( SMPTE_UL != '\x06\x0E\x2B\x34'):
            Log( "Error: Not a SMPTE Universal Lable" )
            return -1
        SMPTE_UL += fp1.read(12)
        if (len(SMPTE_UL) < 16):
            Log( "Error: EOF inside Universal Lable" )
            return -2
        Log( "SMPTE Universal Lable: " + StringToHexString(SMPTE_UL) )

        Length = fp1.read(1)
        if (Length > 127):  # > 0x7F
            #Coded in ASN.1 BER notation
            Length = ord(Length) - 128   # 0x80
            Length = fp1.read(Length)
        Length = StringToNumber(Length)
        Log( "SMPTE KLV package length: " + str(Length) )
        
        ReadPointer = fp1.tell() + Length
        fp1.seek( Length,1 )
        if ( ReadPointer != fp1.tell()):
            Log( "Error: EOF inside Value Element" )
            return -3

        CumLengthDict = AddKeyToDict(CumLengthDict, SMPTE_UL, Length)
        
        Log( "Next KLV starts at: " + str(ReadPointer) )
    
    
    fp1.close()

    Log ("Follows cumulative lengths given UL:")
    for Key, Val in CumLengthDict.iteritems():
        Log (StringToHexString(Key) + " " + str(Val))
    

def AddKeyToDict(dictionery, key, length):
    if (dictionery.has_key(key)):
        CumulativeLength = dictionery[key]
        dictionery[key] = CumulativeLength + length
    else:
        dictionery[key] = length
    return dictionery

def StringToNumber(string):
    OutNumber = 0
    for x in string:
        OutNumber = OutNumber * 256
        OutNumber = OutNumber + ord(x)
    return OutNumber
    

def StringToHexString(string):
    NumDiff = ord('0')
    ChrDiff = ord('A')
    OutString = ""
    for x in string:
        val = ord(x)
        Hval = ((val >> 4) & 15)
        Lval = ( val       & 15)
        if (Hval > 9):
            Hval -= 10
            OutString += chr(Hval + ChrDiff)
        else:
            OutString += chr(Hval + NumDiff)
        if (Lval > 9):
            Lval -= 10
            OutString += chr(Lval + ChrDiff)
        else:
            OutString += chr(Lval + NumDiff)    
    return OutString

def Log_Reset():
    fp1 = file("dump.txt",'w')
    string = "MXF Info script v1.0.0"
    fp1.write(string + "\n")
    #print string
    fp1.close()

def Log(string):
    fp1 = file("dump.txt",'a')
    fp1.write(string + "\n")
    #print string
    fp1.close()

#Main seqence
StartTime = clock()
Log_Reset()
LogMXFInfo("E:\\dk1\\DCP'er\\Breakup_wrapped\\wav_8ae69748-3855-0140-9da1-775eac282bf5_audio.mxf")
LogMXFInfo("E:\\dk1\\DCP'er\\Breakup_wrapped\\wav_11608dd8-ce39-fe4b-9ee6-85376c7be41a_audio.mxf")
Log( "The time it tok to compleat was: " + str( clock() - StartTime ) )
