import datetime

def Log(string):
    fp1 = file("log_dump.txt",'a')
    fp1.write( str(datetime.datetime.utcnow()) + "   " + string + "\n")
    fp1.close()
    print string


def GetFile(filename,param):
    fp1 = file(filename, 'r' + param)
    Buf = fp1.read()
    fp1.close()
    return Buf

def PutFile(buf,filename,param):
    fp1 = file(filename, 'w' + param)
    fp1.write(buf)
    fp1.close()

def Limit(value,lo,up):
    if (value > up):
        return up
    if (value < lo):
        return lo
    return value

def clip(value):
    if (value > 255):
        return 255
    if (value < 0):
        return 0
    return value


def YUV422toYUV444(buf):   #UYVYtoYUV
    Buf = ""
    i = 0
    while (i < len(buf)):
        Buf += buf[i+1]
        Buf += buf[i]
        Buf += buf[i+2]
        Buf += buf[i+3]
        Buf += buf[i]
        Buf += buf[i+2]
        i += 4
    
    return Buf

def YUV444toYUV420(data, width):
    OutData = ""
    length = len(data)

    #Saving Y component
    i=0
    while (i < length):
        OutData += data[i]
        i += 3
    #Saving U component
    i=1
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    #Saving V component
    i=2
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    
    return OutData

def YUV444toRGB888(buf):
    Buf = ""
    i = 0
    while (i < len(buf)):

        Y = ord(buf[i])
        U = ord(buf[i+1])
        V = ord(buf[i+2])

        C = Y - 16
        D = U - 128
        E = V - 128

        R = clip(( 298 * C           + 409 * E + 128) >> 8)
        G = clip(( 298 * C - 100 * D - 208 * E + 128) >> 8)
        B = clip(( 298 * C + 516 * D           + 128) >> 8)
               
        Buf += chr(R)
        Buf += chr(G)
        Buf += chr(B)
        
        i += 3
    
    return Buf

def RGB888toPPM(rgbdata, filename, width, height, comment):
    Buf  = "P6\x0A"
    Buf += "# " + comment + "\x0A"
    Buf += str(width) +" "+ str(height) + "\x0A"
    Buf += "255\x0A"

    fp1 = file(filename, 'wb')
    fp1.write(Buf)
    Buf = MemToString(rgbdata)
    fp1.write(Buf)
    
    fp1.close()
    

def GetValue(string, size, offset):
    Value = 0
    while (size):
        Value *= 256
        Value += ord(string[offset])
        size -= 1
        offset += 1
    return Value

def GetSubString(string, size, offset):
    SubString = ""
    while (size):
        SubString += string[offset]
        size -= 1
        offset += 1
    return SubString
        

def SGItoRGB888(filename):
    Header = {}
    Image = []

    Log("Opening file: " + filename)
    fp1 = open(filename, 'rb')
    HeaderString = fp1.read(512)
    Data = fp1.read()
    fp1.close()

    if (len(HeaderString) < 512):
        Log("Error SGI header to smal.")
        return -1
    
    Header['MAGIC'] = GetValue(HeaderString, 2, 0)
    if (Header['MAGIC'] != 474):
        Log("Error SGI MAGIC identifier inncorect: " + str(Header['MAGIC']))
        return -2

    Header['STORAGE'] = GetValue(HeaderString, 1, 2)
    Header['BPC']     = GetValue(HeaderString, 1, 3)
    Header['DIMENSION'] = GetValue(HeaderString, 2, 4)
    Header['XSIZE'] = GetValue(HeaderString, 2, 6)
    Header['YSIZE'] = GetValue(HeaderString, 2, 8)
    Header['ZSIZE'] = GetValue(HeaderString, 2, 10)
    Header['PIXMIN'] = GetValue(HeaderString, 4, 12)
    Header['PIXMAX'] = GetValue(HeaderString, 4, 16)
    Header['IMAGENAME'] = GetSubString(HeaderString, 80, 24)
    Header['COLORMAP'] = GetValue(HeaderString, 4, 104)

    #Log("Info. SGI Header: " + str(Header))

    #Only implemented uncompresed storage
    if ( Header['STORAGE'] != 0):
        Log("Error SGI is not VERBATIM." )
        return -3
    #Only implemented 3 dimentions
    if ( Header['DIMENSION'] != 3):
        Log("Error SGI is not 3 dimentions." )
        return -4
    #Only implement RGB
    if ( Header['ZSIZE'] != 3):
        Log("Error SGI is not RGB. ")
        return -5    

    CalculatedImageSize = Header['XSIZE'] * Header['YSIZE'] * Header['ZSIZE'] * Header['BPC']
    if (CalculatedImageSize != len(Data)):
        Log("Error SGI image data mismatches header: " + str(len(Data)))
        return -6

    Log("Data Length: " +str(len(Data)))

    Data = StringToMem(Data)
    DimensionSize = Header['XSIZE'] * Header['YSIZE'] * Header['BPC']
    DataR = Data[0:DimensionSize]
    DataG = Data[DimensionSize:DimensionSize*2]
    DataB = Data[DimensionSize*2:DimensionSize*3]
    
 
    OutData = [0] * (CalculatedImageSize /2)
    j = 0
    for i in xrange(0,DimensionSize,Header['BPC']):
        OutData[j] = DataR[DimensionSize - i-2]
        j += 1
        OutData[j] = DataG[DimensionSize - i-2]
        j += 1
        OutData[j] = DataB[DimensionSize - i-2]
        j += 1

    #Log("Data Length: " +str(len(OutData)))

    return (Header,OutData)

def StringToMem(string):
    Start = datetime.datetime.utcnow()
    P =  list(string)
    #print datetime.datetime.utcnow() - Start
    return P


def StringToMem2(string):
    Start = datetime.datetime.utcnow()
    B = [0]*len(string)
    i = 0
    while (i < len(string)):
        B[i] = ord(string[i])
        i += 1
    print datetime.datetime.utcnow() - Start
    return B

def StringToMem1(string):
    Start = datetime.datetime.utcnow()
    P = [ord(a) for a in list(string) ]
    print datetime.datetime.utcnow() - Start
    return P

    
def MemToString1(mem):
    Start = datetime.datetime.utcnow()
    TopString = ""
    String = ""
    i=0

    while (i < len(mem)):
        if ( i %10000 == 0 ):
            TopString += String
            String = ""
        String += chr(mem[i])

        i += 1

    TopString += String
    
    print datetime.datetime.utcnow() - Start
    return TopString

def MemToString2(mem):
    Start = datetime.datetime.utcnow()
    String = ""
    i=0

    while (i < len(mem)):
        String += chr(mem[i])
        i += 1

    
    print datetime.datetime.utcnow() - Start
    return String

def MemToString(mem):
    Start = datetime.datetime.utcnow()
    String = ""
    i=0

    while (i < len(mem)):
        String += mem[i]
        i += 1

    
    #print datetime.datetime.utcnow() - Start
    return String

def Main():
    Log("Starting script yuv8.py")

    FromPath = "%05d.sgi"
    ToPath = "ppm\\%05d.ppm"
    
    for FileNumber in xrange(7111,7611):

        SGIHeader , MemDataRGB = SGItoRGB888(FromPath % FileNumber)
        Log("Finnised with SGI file.")
        
        ContentPPM = RGB888toPPM(MemDataRGB,ToPath % FileNumber , SGIHeader['XSIZE'], SGIHeader['YSIZE'], "Created by Python")
        Log("Compleat RGB888toPPM")
        #PutFile(ContentPPM,ToPath % FileNumber,'b')
        #Log("Compleat Writing of file: " + ToPath % FileNumber)

Main()


