import datetime

def Log(string):
    fp1 = file("log_dump.txt",'a')
    fp1.write( str(datetime.datetime.utcnow()) + "   " + string + "\n")
    fp1.close()
    print string

def YUV10toYUV422(filename):
    

    fp1 = open(filename, 'rb')
    Data = fp1.read()
    fp1.close()

    i = 0
    j = 0
    Image = [0] * (len(Data)*3/4)
    
    while (i < len(Data)):
        Image[j] = ord(Data[i])
        j += 1
        Image[j] = ( ((ord(Data[i+1]) << 2)&252) | ((ord(Data[i+2]) >> 6)&3))
        j += 1
        Image[j] = ( ((ord(Data[i+2]) << 4)&240) | ((ord(Data[i+3]) >> 4)&15) )
        j += 1
        i += 4
        
    return Image

def YUV422toYUV444(buf):   #UYVYtoYUV
    Buf = [0] * (len(buf) *6/4) 
    i = 0
    j = 0
    while (i < len(buf)):
        Buf[j]   = buf[i+1]
        Buf[j+1] = buf[i]
        Buf[j+2] = buf[i+2]
        Buf[j+3] = buf[i+3]
        Buf[j+4] = buf[i]
        Buf[j+5] = buf[i+2]
        j += 6
        i += 4
    
    return Buf

def PutFile(buf,filename,param):
    fp1 = file(filename, 'w' + param)
    fp1.write(buf)
    fp1.close()

def YUV444ToString(mem):
    String = ""
    i=0

    while (i < len(mem)):
        String += chr(mem[i])
        i += 1
    return String

def YUV444toYUV420(data, width):
    OutData = ""
    length = len(data)

    #Saving Y component
    i=0
    while (i < length):
        OutData += data[i]
        i += 3
    #Saving U component
    i=1
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    #Saving V component
    i=2
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    
    return OutData

def YUV444toRGB888(buf):
    i = 0
    while (i < len(buf)):

        Y = buf[i]
        U = buf[i+1]
        V = buf[i+2]

        C = Y - 16
        D = U - 128
        E = V - 128

        R = clip(( 298 * C           + 409 * E + 128) >> 8)
        G = clip(( 298 * C - 100 * D - 208 * E + 128) >> 8)
        B = clip(( 298 * C + 516 * D           + 128) >> 8)
               
        buf[i]   = R
        buf[i+1] = G
        buf[i+2] = B
        
        i += 3
    
    return buf

def clip(value):
    if (value > 255):
        return 255
    if (value < 0):
        return 0
    return value

def RGB888toPPM(rgbdata, filename, width, height, comment):
    Buf  = "P6\x0A"
    Buf += "# " + comment + "\x0A"
    Buf += str(width) +" "+ str(height) + "\x0A"
    Buf += "255\x0A"

    fp1 = file(filename, 'wb')
    fp1.write(Buf)
    Buf = YUV444ToString(rgbdata)
    fp1.write(Buf)
    
    fp1.close()


def Main():
    Log("Starting script yuv10.py")

    FromPath = "NewClip004_%07d.yuv10"
    ToPath = "ppm\\%05d.ppm"
    
    for FileNumber in xrange(0,2):
        
        Log("Opening file: " + FromPath % FileNumber)
        ImageYUV422 = YUV10toYUV422(FromPath % FileNumber)
        Log("Compleat YUV10toYUV422")
        ImageYUV444 = YUV422toYUV444(ImageYUV422)
        Log("Compleat YUV422toYUV444")
        ImageRGB888 = YUV444toRGB888(ImageYUV444)
        Log("Compleat YUV444toRGB888")
        RGB888toPPM(ImageRGB888, ToPath % FileNumber , 1920, 1080, "Created by Python")
        Log("Compleat RGB888toPPM")

Main()

        
