
def GetFile(filename,param):
    fp1 = file(filename, 'r' + param)
    Buf = fp1.read()
    fp1.close()
    return Buf

def PutFile(buf,filename,param):
    fp1 = file(filename, 'w' + param)
    fp1.write(buf)
    fp1.close()

def Limit(value,lo,up):
    if (value > up):
        return up
    if (value < lo):
        return lo
    return value

def clip(value):
    if (value > 255):
        return 255
    if (value < 0):
        return 0
    return value


def YUV422toYUV444(buf):   #UYVYtoYUV
    Buf = ""
    i = 0
    while (i < len(buf)):
        Buf += buf[i+1]
        Buf += buf[i]
        Buf += buf[i+2]
        Buf += buf[i+3]
        Buf += buf[i]
        Buf += buf[i+2]
        i += 4
    
    return Buf

def YUV444toYUV420(data, width):
    OutData = ""
    length = len(data)

    #Saving Y component
    i=0
    while (i < length):
        OutData += data[i]
        i += 3
    #Saving U component
    i=1
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    #Saving V component
    i=2
    while (i < length):
        line = i / (3*width)
        if((line %2) == 0):
            OutData += data[i]
        i += 3*2
    
    return OutData

def YUV444toRGB888(buf):
    Buf = ""
    i = 0
    while (i < len(buf)):

        Y = ord(buf[i])
        U = ord(buf[i+1])
        V = ord(buf[i+2])

        C = Y - 16
        D = U - 128
        E = V - 128

        R = clip(( 298 * C           + 409 * E + 128) >> 8)
        G = clip(( 298 * C - 100 * D - 208 * E + 128) >> 8)
        B = clip(( 298 * C + 516 * D           + 128) >> 8)
               
        Buf += chr(R)
        Buf += chr(G)
        Buf += chr(B)
        
        i += 3
    
    return Buf

def RGB888toPPM(buf, width, height, comment):
    Buf  = "P6\x0A"
    Buf += "# " + comment + "\x0A"
    Buf += str(width) +" "+ str(height) + "\x0A"
    Buf += "255\x0A"
    return Buf + buf
    

Content = GetFile("720p50dance8bit_00000.yuv8",'b')
Content = YUV422toYUV444(Content)
ContentRGB = YUV444toRGB888(Content)
#PutFile(ContentRGB,"imRGB888_720p.raw",'b')
#Content420 = YUV444toYUV420(Content,1280)
#PutFile(Content420,"imYUV420_720p.yuv",'b')
ContentPPM = RGB888toPPM(ContentRGB, 1280, 720, "Created by Python")
PutFile(ContentPPM,".\\ppm\\720p50dance8bit_00000.ppm",'b')




